/**
 * 遍历节点
 */
export interface TraverseNode {
}
/**
 * 遍历节点相关参数
 */
export interface TraverseNodeParams<T extends TraverseNode> {
    path: Array<T>;
    isFirst: boolean;
    isLast: boolean;
    isLeaf: boolean;
}
/**
 * 遍历谓语结果
 */
export interface PredicateResult<T extends TraverseNode> {
    done: boolean;
    iterators: Array<T>;
}
/**
 * 节点遍历谓语
 */
export declare type TraversePredicate<T extends TraverseNode> = (node: T) => PredicateResult<T>;
/**
 * 文件节点处理方法
 */
export declare type TraverseNodeHandler<T extends TraverseNode> = (node: T, nodeParams: TraverseNodeParams<T>, options: TraverseOptions<T>, result: TraverseResult) => T;
export interface TraverseConditionOptions<T extends TraverseNode> {
    readonly exclude?: (node: TraverseNode, nodeParams: TraverseNodeParams<T>, options: TraverseOptions<T>) => boolean;
    readonly ignore?: (node: TraverseNode, nodeParams: TraverseNodeParams<T>, options: TraverseOptions<T>) => boolean;
}
export interface TraverseHandleOptions<T extends TraverseNode> {
    readonly predicate: TraversePredicate<T>;
    readonly nodeHandle: TraverseNodeHandler<T>;
}
/**
 * 遍历选项
 */
export declare type TraverseOptions<T> = TraverseConditionOptions<T> & TraverseHandleOptions<T>;
export interface TraverseResult {
    [propName: string]: any;
}
export declare function traverseRecursive<T>(nodes: T[], options: TraverseOptions<T>): TraverseResult;
