/// <reference types="node" />
import fs from "fs";
import { TraverseNode, TraverseNodeParams, TraverseConditionOptions } from "../traverse-core/traverse-recursive";
import { PlainObject } from "../shared/types";
/**
 * 文件节点
 */
export interface FileNode extends TraverseNode {
    fileName: string;
    filePath: string;
    fileStatus: fs.Stats;
}
interface FileTraverseInnerOptions {
    fileNodeHandle?: FileNodeHandle;
    [propName: string]: any;
}
export declare type FileTraverseOptions = FileTraverseInnerOptions & TraverseConditionOptions<FileNode>;
export declare type FileNodeHandle = (node: FileNode, params: TraverseNodeParams<FileNode>, options: FileTraverseOptions, result: PlainObject) => void;
export declare function traverseFiles(directories: string[], options: FileTraverseOptions): import("../traverse-core/traverse-recursive").TraverseResult;
export {};
